// PacketEchoServerDLL.cpp : Defines the exported functions for the DLL application.
//

#define WASP_MAP_W_AND_A

#include "WASPPluginSDK\WASPDLLEntryPoints.h"

#include "ServerInstance.h"

#pragma comment(lib, "ws2_32.lib")

WaspInstanceHandle __cdecl Initialise(
   WaspFunctions *pWaspFunctions,
   const char *pConfigValue)
{
   if (pWaspFunctions->size < sizeof(WaspFunctions))
   {
      // By testing to see that the supplied function table is
      // larger than or equal to our function table we can 
      // return an error which indicates that we failed to
      // initialise if we have been built expecting a later 
      // (and therefore larger) function table than the version 
      // of WASP that is hosting us is supplying us.

      return 0;
   }

   WaspInstanceHandle handle = 0;

   try
   {
      CServerInstance *pServer = new CServerInstance(
         pConfigValue, 
         pWaspFunctions);

      handle = reinterpret_cast<WaspInstanceHandle>(pServer);
   }
   catch (...)
   {
      // mustn't let exceptions leak from our entry points...
   }

   return handle;
}

unsigned long __cdecl GetMinimumMessageSize()
{
   return sizeof(int);
}

unsigned long __cdecl GetMessageSize(
   const WaspConnectionHandle connectionHandle,
   WaspConnectionUserData connectionUserData,
   const BYTE * const pData,
   const WaspDataLength dataLength,
   const WaspDataLength previousLength)
{
   (void)connectionHandle;
   (void)connectionUserData;
   (void)dataLength;
   (void)previousLength;

   return ntohl(*reinterpret_cast<const int *>(pData)) + sizeof(int);
}

void __cdecl OnReadCompleted(
   const WaspInstanceHandle instanceHandle,
   const WaspConnectionHandle connectionHandle,
   WaspConnectionUserData connectionUserData,
   const BYTE * const pDataIn,
   const WaspDataLength dataLength)
{
   CServerInstance *pInstance = reinterpret_cast<CServerInstance *>(instanceHandle);

   pInstance->OnReadCompleted(
      connectionHandle, 
      connectionUserData,
      pDataIn,
      dataLength);
}

void __cdecl Shutdown(
   const WaspInstanceHandle instanceHandle)
{
   CServerInstance *pInstance = reinterpret_cast<CServerInstance *>(instanceHandle);

   delete pInstance;
}

