#include "ServerInstance.h"

using std::string;

CServerInstance::CServerInstance(
   const char *pConfigValue,
   const WaspFunctions *pWaspFunctions)
   :  m_configValue(pConfigValue)
{
   memset(&m_waspFunctions, 0, sizeof(m_waspFunctions));

   memcpy(&m_waspFunctions, pWaspFunctions, sizeof(m_waspFunctions));

   m_waspFunctions.size = sizeof(m_waspFunctions);

   const string message = m_configValue + ": Instance created";

   m_waspFunctions.logMessageA(m_waspFunctions.id, 0, message.c_str());
}

CServerInstance::~CServerInstance()
{
   const string message = m_configValue + ": Instance destroyed";

   m_waspFunctions.logMessageA(m_waspFunctions.id, 0, message.c_str());
}

void CServerInstance::OnReadCompleted(
   const WaspConnectionHandle connectionHandle,
   WaspConnectionUserData connectionUserData,
   const BYTE * const pDataIn,
   const WaspDataLength dataLength)
{
   const string message = m_configValue + ": OnReadCompleted()";

   m_waspFunctions.logMessageA(m_waspFunctions.id, 0, message.c_str());

   (void)connectionUserData;

   const WaspError waspError = m_waspFunctions.writeToConnection(m_waspFunctions.id, connectionHandle, pDataIn, dataLength);

   if (WaspNoError != waspError)
   {
      const string message = m_configValue + ": writeToConnection failed - " + m_waspFunctions.getErrorMessageA(m_waspFunctions.id, waspError);

      m_waspFunctions.logMessageA(m_waspFunctions.id, 0, message.c_str());
   }
}